aboutsummaryrefslogtreecommitdiff
path: root/development
diff options
context:
space:
mode:
authorAntonio Leal <antonioleal@yahoo.com>2024-01-27 08:01:54 +0700
committerWilly Sudiarto Raharjo <willysr@slackbuilds.org>2024-01-27 10:16:20 +0700
commita15a7d581d5c249ff8047affa8ccb9be8b2c9e58 (patch)
tree0f1e7ffe4400b77d0c4395d4e79d513d72484a10 /development
parent264b0341960443074f9de3c478ecd7ee2dc9f8bf (diff)
development/SmallBASIC: Added (SmallBASIC).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development')
-rw-r--r--development/SmallBASIC/README35
-rw-r--r--development/SmallBASIC/SmallBASIC.SlackBuild146
-rw-r--r--development/SmallBASIC/SmallBASIC.info14
-rw-r--r--development/SmallBASIC/doinst.sh13
-rw-r--r--development/SmallBASIC/slack-desc19
5 files changed, 227 insertions, 0 deletions
diff --git a/development/SmallBASIC/README b/development/SmallBASIC/README
new file mode 100644
index 0000000000000..70dc2f4f9e625
--- /dev/null
+++ b/development/SmallBASIC/README
@@ -0,0 +1,35 @@
+SmallBASIC is a fast and easy to learn BASIC language interpreter
+ideal for everyday calculations, scripts and prototypes. SmallBASIC
+includes trigonometric, matrices and algebra functions, a built in
+IDE, a powerful string library, system, sound, graphic commands and
+communication via serial or sockets along with structured
+programming syntax.
+
+SmallBASIC is available for various operating systems, including
+Windows, Linux, and Android. You can even build it from source to
+run on many other POSIX-compliant systems, such as Raspberry Pi OS
+for the Raspberry Pi. With its built-in Integrated Development
+Environment (IDE), you can write programs on your Android-powered
+tablet or mobile phone and run them instantly.
+If you want to get started, you can download SmallBASIC from our
+Downloads page.
+
+SmallBASIC makes it easy to bundle your program with all the
+necessary libraries, creating executable files for Windows
+(exe-files) or Linux (AppImage).
+For Android, you can create a signed package (pkg) and
+distribute it through platforms like Google Play. Learn more
+about distributing your program on our (Distribution) page.
+
+If you prefer an online experience, you can start programming
+with the web-based version of SmallBASIC in your browser right now.
+Just click on Start online to begin coding.
+
+This Slackware package produces 3 executables:
+ - sbasici - Using FLTK graphics
+ - sbasicg - Using SDL graphics
+ - sbasic - the Console (text only)
+
+See the online samples from the run menu or the provided
+examples at /usr/share/SmallBASIC
+(some run only on the SDL version)
diff --git a/development/SmallBASIC/SmallBASIC.SlackBuild b/development/SmallBASIC/SmallBASIC.SlackBuild
new file mode 100644
index 0000000000000..df25d96146135
--- /dev/null
+++ b/development/SmallBASIC/SmallBASIC.SlackBuild
@@ -0,0 +1,146 @@
+#!/bin/bash
+
+# Slackware build script for SmallBASIC
+
+# Copyright 2024 Antonio Leal, Porto Salvo, Oeiras, Portugal
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=SmallBASIC
+VERSION=${VERSION:-12.26}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+FLTKTARBALL=fltk-1.4.x-20240119-01f2f760
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf /tmp/$FLTKTARBALL
+rm -rf $FLTKTARBALL $PRGNAM-$VERSION
+rm -rf $TMP/${VERSION/./_}
+
+tar xvfz $CWD/$FLTKTARBALL.tar.gz
+tar xvfz $CWD/${PRGNAM,,}-$VERSION.tar.gz
+unzip $CWD/${PRGNAM,,}_$VERSION.zip "${VERSION/./_}/examples/*"
+
+fixperms() {
+ chown -R root:root .
+ find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+}
+
+# Build statical FLTK libraries
+(
+ cd $FLTKTARBALL
+ fixperms
+ ./autogen.sh
+ ./configure --prefix=/tmp/$FLTKTARBALL
+ make -j1
+ make install
+)
+
+cd ${PRGNAM,,}-$VERSION
+fixperms
+
+# Build Console Version
+./configure
+make -j1
+make install DESTDIR=$PKG
+
+# Build SDL Version
+make clean
+./configure --enable-sdl
+make -j1
+make install DESTDIR=$PKG
+mv $PKG/usr/local/share/applications/io.github.smallbasic.desktop $PKG/usr/local/share/applications/smallbasic-sdl.desktop
+sed -i -e "s/SmallBASIC/SmallBASIC (SDL)/" $PKG/usr/local/share/applications/smallbasic-sdl.desktop
+
+# Build FLTK Version
+make clean
+export PATH=/tmp/$FLTKTARBALL/bin:$PATH
+CFLAGS="-I/tmp/$FLTKTARBALL/include" LDFLAGS="-L/tmp/$FLTKTARBALL/lib" ./configure --enable-fltk
+make
+make install DESTDIR=$PKG
+mv $PKG/usr/local/share/applications/io.github.smallbasic.desktop $PKG/usr/local/share/applications/smallbasic-fltk.desktop
+sed -i -e "s/SmallBASIC/SmallBASIC (FLTK)/" $PKG/usr/local/share/applications/smallbasic-fltk.desktop
+
+# Place files at the correct locations
+mkdir -p $PKG/usr/bin -p $PKG/usr/share/pixmaps $PKG/usr/share/applications $PKG/usr/share/$PRGNAM
+mv $PKG/usr/local/bin/* $PKG/usr/bin
+mv $PKG/usr/local/share/icons/hicolor/128x128/apps/sb-desktop-128x128.png $PKG/usr/share/pixmaps
+mv $PKG/usr/local/share/applications/* $PKG/usr/share/applications
+mv $TMP/${VERSION/./_}/examples $PKG/usr/share/$PRGNAM
+
+# Clean-up
+rm -rf $PKG/usr/local
+rm -rf /tmp/$FLTKTARBALL
+rm -rf $TMP/${VERSION/./_}
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/SmallBASIC/SmallBASIC.info b/development/SmallBASIC/SmallBASIC.info
new file mode 100644
index 0000000000000..bc79c9e7e21d5
--- /dev/null
+++ b/development/SmallBASIC/SmallBASIC.info
@@ -0,0 +1,14 @@
+PRGNAM="SmallBASIC"
+VERSION="12.26"
+HOMEPAGE="https://smallbasic.github.io"
+DOWNLOAD="https://github.com/smallbasic/SmallBASIC/releases/download/12_26/smallbasic-12.26.tar.gz \
+ https://www.fltk.org/pub/fltk/snapshots/fltk-1.4.x-20240119-01f2f760.tar.gz \
+ https://github.com/smallbasic/SmallBASIC/releases/download/12_26/smallbasic_12.26.zip"
+MD5SUM="33d227f2be855e2aed60e761f563c038 \
+ 7e2954731c18fd179ef3250b31e09cb9 \
+ ca5e146d0afb50d4c9b9f66d5f32d100"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Antonio Leal"
+EMAIL="antonioleal@yahoo.com"
diff --git a/development/SmallBASIC/doinst.sh b/development/SmallBASIC/doinst.sh
new file mode 100644
index 0000000000000..aea0f894eb32b
--- /dev/null
+++ b/development/SmallBASIC/doinst.sh
@@ -0,0 +1,13 @@
+if [ -x /usr/bin/update-desktop-database ]; then
+ /usr/bin/update-desktop-database -q usr/share/applications >/dev/null 2>&1
+fi
+
+if [ -x /usr/bin/update-mime-database ]; then
+ /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+if [ -e usr/share/icons/hicolor/icon-theme.cache ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ /usr/bin/gtk-update-icon-cache -f usr/share/icons/hicolor >/dev/null 2>&1
+ fi
+fi
diff --git a/development/SmallBASIC/slack-desc b/development/SmallBASIC/slack-desc
new file mode 100644
index 0000000000000..8da20195c25e3
--- /dev/null
+++ b/development/SmallBASIC/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+SmallBASIC: SmallBASIC (basic-interpreter)
+SmallBASIC:
+SmallBASIC: SmallBASIC is a fast and easy to learn BASIC language interpreter
+SmallBASIC: ideal for everyday calculations, scripts and prototypes.
+SmallBASIC: SmallBASIC includes trigonometric, matrices and algebra functions,
+SmallBASIC: a built in IDE, a powerful string library, system, sound, graphic
+SmallBASIC: commands and communication via serial or sockets along with
+SmallBASIC: structured programming syntax.
+SmallBASIC:
+SmallBASIC: SmallBASIC includes online examples ready to run.
+SmallBASIC: